!DIR$ FIXEDFORMLINESIZE:132
      include 'formats.f'
      include 'blocks.f'
      include 'Fourier.f'
      include 'index.f'
      include 'OptF.f'
      program MakeData
      use formats
      use blocks
      use Fourier
      implicit none

      real*8 prob, prob_max
      integer*4 i, ind, info, nprec, len
      logical*4 flag
      integer*4, allocatable, dimension(:) :: bmod

      write(6,f1,advance='yes') '*********************************************************'
      write(6,f1,advance='no' ) '> Give the model vector of odd length, N: '
 100  continue
      read(*,*) N
      if     (N .le. 1) then
         write(6,f1,advance='no') '> N should be greater than 1; give another N: '
         goto 100
      else if(mod(N,2) .eq. 0) then
         write(6,f1,advance='no') '> N should be odd; give another N: '
         goto 100
      end if
      write(6,f1,advance='yes') '*********************************************************'

      Nm1 = N-1
      M   = Nm1/2
      prob_max = dfloat(M)/dfloat(N)
      del = two*pi/dfloat(N)
      LN = M*N
      allocate(E(0:LN))
      call make_E()

      write(6,f1,advance='yes') '>....... Create data using a model file, --- [1]'
      write(6,f1,advance='yes') '> or a random vector with given N and r, --- [2]'
      write(6,f1,advance='yes') '> or a random vector with given N and p(1)?  [3]'
      write(6,f1,advance='no' ) '>............... Enter selection [1, 2 or 3]: '
 101  continue
      read(*,*) ind
      
      if     (ind .eq. 1) then

         write(6,f1,advance='yes') '> Will attempt to read model vector from "mod.dat"...'

      else if(ind .eq. 2) then

         write(6,f1,advance='yes') '> Will build random vector of length N and popcount r and write it to "mod.dat"...'
         write(6,f1,advance='no' ) '> Give the desired popcount r: '
 102     continue
         read(*,*) N1
         if     (N1 .le. 0) then
            write(6,f1,advance='no') '> Popcount should be greater than 0; repeat: '
            goto 102
         else if(N1 .gt. M) then
            write(6,f3,advance='no') '> Popcount should be <= M, where M=', M, ' ; repeat: '
            goto 102
         end if

      else if(ind .eq. 3) then

         write(6,f1,advance='yes') '> Will build random vector of length N and p(1)=prob, and write it to "mod.dat"...'
         write(6,f1,advance='no' ) '> Give the desired prob: '
 103     continue
         read(*,*) prob
         if     (prob .le. 0) then
            write(6,f1,advance='no') '> prob should be greater than 0; repeat: '
            goto 103
         else if(prob .ge. prob_max) then
            fv = '(a,f5.3,a)'
            write(6,fv,advance='no') '> prob should be <= prob_max=M/N. Here prob_max=', sngl(prob_max), ' ; repeat: '
            goto 103
         end if
         
      else

         write(6,f1,advance='no') '> Incorrect input; please enter one of the number 1, 2 or 3; repeat: '
         goto 101

      end if
      write(6,f1,advance='yes') '*********************************************************'

      allocate(bmod(0:Nm1))
      call make_mod(ind, prob, bmod, info)

      if(info .eq. 0) then

         if(ind .eq. 1) then
            write(6,f1) '> Model successfully read from "mod.dat"'
            len = max(log10(dfloat(N))+2.0, 10.0)
         else
            write(6,f1) '> Random model successfully constructed'
         end if
         len = max(log10(dfloat(N))+2.0, 10.0)
         write(fv,f3) '(a, i', len, ', a)'
         write(6, fv) '>  N  =', N  , ' [  Length of the binary vector   ]'
         write(6, fv) '>  r  =', N1 , ' [        The popcount, r         ]'

      else

         write(6,f3) '> There were errors in make_mod, info=', info, ' ; exiting'
         stop

      end if
      
      if(ind .gt. 1) then
         write(6,f1, advance='no') '> Write the generated vector to "mod.dat" [T/F]? : '
         read (5,f6)  flag
         if(flag) then
            fname = trim('mod.dat')
            call dump_b(fname, bmod)
         end if
      end if

      write(6,f1,advance='yes') '*********************************************************'
      write(6,f1,advance='no' ) '> Give the data bandwidth, L: '
 104  continue
      read(*,*) L
      if     (L .lt. 1) then
         write(6,f1,advance='no') '> L should be greater than 0; give another L: '
         goto 104
      else if(L .gt. M) then
         write(6,f3,advance='no') '> L should be <= M, where M=', M, '; give another L: '
         goto 104
      end if
      write(6,f1,advance='yes') '*********************************************************'

      write(6,f1,advance='no') '> Give number of significant figures in data, nprec in [1,17]: '
 105  continue
      read(*,*) nprec
      if     (nprec .le. 1) then
         write(6,f1,advance='no') '> nprec should be greater than 1; give another nprec: '
         goto 105
      else if(nprec .gt. 17) then
         write(6,f1,advance='no') '> nprec should <=17; give another nprec: '
         goto 105
      end if

      len = log10(dfloat(L))+1.0 
      fv = '(a, i0, a, i0, a, i0, a)'
      write(fv, fv) '(i', len, ', 2es', nprec+9, '.', nprec-1, ')'

      allocate(phi(1:L))
      call DFT_dir_b(1,L,bmod,phi)
      open(unit=70, file='phi.dat', status='unknown')
      write(70,f4) N, ' ', N1
      do i=1,L
         write(70,fv) i, dreal(phi(i)), dimag(phi(i))
      end do
      close(unit=70)

      stop
      end
