!DIR$ FIXEDFORMLINESIZE:132
      subroutine OptFSolver(rbnd,bsol,info)
      use blocks
      use OptF
      implicit none
      real*8   , intent(in)  :: rbnd(0:Nm1)
      integer*4, intent(out) :: bsol(0:Nm1)
      integer*4, intent(out) :: info

      complex*16 z(1:L)
      real*8   , dimension(0:Nm1) :: r, t, rmin
      real*8   , dimension(Lp1:M) :: rn1, rn2, rn3, rn4
      integer*4, dimension(0:Nm1) :: btst

      real*8    F0, F, F_min, cfc
      real*8    chi, chi_min, fchi
      integer*4 i, ind, iter
      logical*4 flag
      
c$$$      integer*4, allocatable, dimension(:) :: seed
c$$$      integer*4 is
c$$$      call random_seed(SIZE=is)
c$$$      allocate(seed(is))
c$$$      call random_seed(GET=seed)
c$$$      do i=1,is
c$$$         write(*,*) i, seed(i)
c$$$      end do
c$$$      call random_seed(PUT=seed)


 400  format(a12,i8,a3,es12.2)

      r       = rbnd
      rmin    = rbnd
      F_min   = gig
      chi_min = gig
      cfc     = cfc_ini

      if     (IndStopIterCnd .eq. 1) then      
         write(*,*) 'OptFSolver:    iter |     chi_min'
      else if(IndStopIterCnd .eq. 2) then      
         write(*,*) 'OptFSolver:    iter |      F_min'
      else
         info = -101
         return
      end if

      iter = 0
 100  continue
      iter = iter + 1

      ind = 0
      call make_F(r,F0)

      i = 0
 200  continue
      i = i + 1
      if     (ind .eq. 0) then
         call tune_r_stp(r)
      else if(ind .eq. 1) then
         call tune_r_1(r)
      else if(ind .eq. 2) then
         call tune_r_2(r)
      else if(ind .eq. 3) then
         call tune_r_3(r)
      end if

      call make_F(r,F)

      if(F0/F-ru .gt. rmprec) then

         F0 = F
         goto 200

      else

         call check_min(r, flag)
         if(flag) then
            if(ind .lt. 3) then
               ind = ind+1
               goto 200
            else
               if(IndLocalMinVer .eq. 1) then
                  info = -1
                  return
               end if
            end if
         end if

      end if


      IF(IndStopIterCnd .eq. 1) THEN

         call roughen(r,btst)
         call DFT_dir_b(1,L,btst,z)
         chi = fchi(1,L,z,phi)

         if(chi .lt. chi_min) then
            chi_min = chi
            rmin    = r
            write(*,400) 'OptFSolver:', iter, ' | ', sngl(chi_min)
         end if
         
         if(chi .le. eps) then
            bsol = btst
            info = 0
            return
         end if

      ELSE IF(IndStopIterCnd .eq. 2) THEN

         if(F .lt. F_min) then
            F_min = F
            rmin  = r
            write(*,400) 'OptFSolver:', iter, ' | ', sngl(F_min)
         end if

         if(F .le. eps) then
            call roughen(r,bsol)
            info = 0
            return
         end if

      ELSE

         info = -102
         return

      END IF

      if(iter .gt. iter_max) then
         call roughen(rmin,bsol)
         info = 1
         return
      end if

      if(mod(iter,iter_inc) .eq. 0) then
         cfc = min(cfc + cfc_inc, cfc_max)
      end if
      
      if     (IndStartRandom .eq. 1) then
         r = rmin
      else if(IndStartRandom .eq. 2) then
         r = rbnd
      else if(IndStartRandom .eq. 3) then
         continue
      else
         info = -104
         return
      end if

      call random_number(rn1)
      call random_number(rn2)
      call random_number(rn3)
      call random_number(rn4)
      call random_dir(rn1,rn2,rn3,rn4,t)
  
      r = r + cfc*t

      goto 100
 

      end

