!DIR$ FIXEDFORMLINESIZE:132
      subroutine check_OptF_pars(info)
      use blocks
      use OptF
      implicit none
      integer*4, intent(out) :: info

      real*8 cfc_ini_loc, cfc_inc_loc, cfc_max_loc
      real*8 rmprec_loc, rmcerr_loc
      integer*4 iter_inc_loc, iter_max_loc
      integer*4 IndStartRandom_loc
      integer*4 IndStopIterCnd_loc, IndLocalMinVer_loc

      real*8    a, b
      integer*4 c, d
      parameter(a=1.0d-3, b=1.0d6, c=100, d=1e9)

      logical*4 flag


 400  format(a54        )
 401  format(a43,   f6.1)
 402  format(a43, es12.2)
 403  format(a43,  i10  )
 404  format(a43,  i2   )
 405  format(a43,  2i10 )

      info = 0

      inquire(file='OptF.par', exist=flag)
      if(.not. flag) then
         info = -1
         return
      end if

      open(unit=70, file='OptF.par', status='old',err=100)
                                                     ! Default  Allowed 
      read(70,*,err=101,end=101) cfc_ini_loc         ! 1.0      [a, b]
      read(70,*,err=102,end=102) cfc_inc_loc         ! 1.0      [a, b]
      read(70,*,err=103,end=103) cfc_max_loc         ! 1.0d4    [a, b]
      read(70,*,err=104,end=104) iter_inc_loc        ! 1e3      [1, d]
      read(70,*,err=105,end=105) iter_max_loc        ! 1e6      [c, d]
      read(70,*,err=106,end=106) rmprec_loc          ! 5.0d-16  [0, a]
      read(70,*,err=107,end=107) rmcerr_loc          ! 1.0d-8   [0, a]
      read(70,*,err=108,end=108) IndStartRandom_loc  ! 1        {1,2,3}
      read(70,*,err=109,end=109) IndStopIterCnd_loc  ! 1        {1,2}
      read(70,*,err=110,end=110) IndLocalMinVer_loc  ! 1        {0,1}

      close(unit=70)

      
      if     (cfc_ini_loc .lt. a)       then ! Par 1
         write(*,400) 'check_OptF_pars: cfc_ini too small;      not changing'
      else if(cfc_ini_loc .gt. b)       then
         write(*,400) 'check_OptF_pars: cfc_ini too large;      not changing'
      else if(cfc_ini_loc .eq. cfc_ini) then
         write(*,400) 'check_OptF_pars: cfc_ini=default;        not changing'
      else
         cfc_ini = cfc_ini_loc
         info = info + 1
         write(*,401) 'check_OptF_pars: cfc_ini........new value:', sngl(cfc_ini)
      end if

      if     (cfc_inc_loc .lt. a)       then ! Par 2
         write(*,400) 'check_OptF_pars: cfc_inc too small;      not changing'
      else if(cfc_inc_loc .gt. b)       then
         write(*,400) 'check_OptF_pars: cfc_inc too large;      not changing'
      else if(cfc_inc_loc .eq. cfc_inc) then
         write(*,400) 'check_OptF_pars: cfc_inc=default;        not changing'
      else
         cfc_inc = cfc_inc_loc
         info = info + 1
         write(*,401) 'check_OptF_pars: cfc_inc........new value:', sngl(cfc_inc)
      end if

      if     (cfc_max_loc .lt. a)       then ! Par 3
         write(*,400) 'check_OptF_pars: cfc_max too small;      not changing'
      else if(cfc_max_loc .gt. b)       then
         write(*,400) 'check_OptF_pars: cfc_max too large;      not changing'
      else if(cfc_max_loc .eq. cfc_max) then
         write(*,400) 'check_OptF_pars: cfc_max=default;        not changing'
      else
         cfc_max = cfc_max_loc
         info = info + 1
         write(*,401) 'check_OptF_pars: cfc_max........new value:', sngl(cfc_max)
      end if

      if     (iter_inc_loc .lt. 1)        then ! Par 4
         write(*,400) 'check_OptF_pars: iter_inc<1;             not changing'
      else if(iter_inc_loc .gt. d )       then
         write(*,400) 'check_OptF_pars: iter_inc too large;     not changing'
      else if(iter_inc_loc .eq. iter_inc) then
         write(*,400) 'check_OptF_pars: iter_inc=default;       not changing'
      else
         iter_inc = iter_inc_loc
         info = info + 1
         write(*,403) 'check_OptF_pars: iter_inc.......new value:', iter_inc
      end if
        
      if     (iter_max_loc .lt. c)        then ! Par 5
         write(*,400) 'check_OptF_pars: iter_max too small;     not changing'
      else if(iter_max_loc .gt. d )       then
         write(*,400) 'check_OptF_pars: iter_max too large;     not changing'
      else if(iter_max_loc .eq. iter_max) then
         write(*,400) 'check_OptF_pars: iter_max=default;       not changing'
      else
         iter_max = iter_max_loc
         info = info + 1
         write(*,403) 'check_OptF_pars: iter_max.......new value:', iter_max
      end if

      if     (rmprec_loc .lt. rz)     then ! Par 6
         write(*,400) 'check_OptF_pars: rmprec negative;        not changing'
      else if(rmprec_loc .gt. a )     then
         write(*,400) 'check_OptF_pars: rmprec too large;       not changing'
      else if(rmprec_loc .eq. rmprec) then
         write(*,400) 'check_OptF_pars: rmprec=default;         not changing'
      else
         rmprec = rmprec_loc
         info = info + 1
         write(*,402) 'check_OptF_pars: rmprec.........new value:', sngl(rmprec)
         write(*,400) 'check_OptF_pars: CHANGING  rmprec  IS NOT RECOMMENDED'
      end if

      if     (rmcerr_loc .lt. rz)     then ! Par 7
         write(*,400) 'check_OptF_pars: rmcerr negative;        not changing'
      else if(rmcerr_loc .gt. a )     then
         write(*,400) 'check_OptF_pars: rmcerr too large;       not changing'
      else if(rmcerr_loc .eq. rmcerr) then
         write(*,400) 'check_OptF_pars: rmcerr=default;         not changing'
      else
         rmcerr = rmcerr_loc
         info = info + 1
         write(*,402) 'check_OptF_pars: rmcerr........ new value:', sngl(rmcerr)
      end if

      if     (IndStartRandom_loc .lt. 1)              then ! Par 8
         write(*,400) 'check_OptF_pars: IndStartRandom<1;       not changing'
      else if(IndStartRandom_loc .gt. 3 )             then
         write(*,400) 'check_OptF_pars: IndStartRandom>3;       not changing'
      else if(IndStartRandom_loc .eq. IndStartRandom) then
         write(*,400) 'check_OptF_pars: IndStartRandom=default; not changing'
      else
         IndStartRandom = IndStartRandom_loc
         info = info + 1
         write(*,404) 'check_OptF_pars: IndStartRandom new value:', IndStartRandom
      end if

      if     (IndStopIterCnd_loc .lt. 1)              then ! Par 9
         write(*,400) 'check_OptF_pars: IndStopIterCnd<1;       not changing'
      else if(IndStopIterCnd_loc .gt. 2 )             then
         write(*,400) 'check_OptF_pars: IndStopIterCnd>2;       not changing'
      else if(IndStopIterCnd_loc .eq. IndStopIterCnd) then
         write(*,400) 'check_OptF_pars: IndStopIterCnd=default; not changing'
      else
         IndStopIterCnd = IndStopIterCnd_loc
         info = info + 1
         write(*,404) 'check_OptF_pars: IndStopIterCnd new value:', IndStopIterCnd
      end if

      if     (IndLocalMinVer_loc .lt. 0)              then ! Par 10
         write(*,400) 'check_OptF_pars: IndLocalMinVer<0;       not changing'
      else if(IndLocalMinVer_loc .gt. 1 )             then
         write(*,400) 'check_OptF_pars: IndLocalMinVer>1;       not changing'
      else if(IndLocalMinVer_loc .eq. IndLocalMinVer) then
         write(*,400) 'check_OptF_pars: IndLocalMinVer=default; not changing'
      else
         IndLocalMinVer = IndLocalMinVer_loc
         info = info + 1
         write(*,404) 'check_OptF_pars: IndLocalMinVer new value:', IndLocalMinVer
      end if

      return

 100  continue
      write(*,*) 'check_OptF_pars: Error opening OptF.par'
      info = 100
      return

 101  continue
      write(*,*) 'check_OptF_pars: Error reading [cfc_ini]'
      info = 101
      return

 102  continue
      write(*,*) 'check_OptF_pars: Error reading [cfc_inc]'
      info = 102
      return

 103  continue
      write(*,*) 'check_OptF_pars: Error reading [cfc_max]'
      info = 103
      return

 104  continue
      write(*,*) 'check_OptF_pars: Error reading [iter_inc]'
      info = 104
      return

 105  continue
      write(*,*) 'check_OptF_pars: Error reading [iter_max]'
      info = 105
      return

 106  continue
      write(*,*) 'check_OptF_pars: Error reading [rmprec]'
      info = 106
      return

 107  continue
      write(*,*) 'check_OptF_pars: Error reading [rmcerr]'
      info = 107
      return

 108  continue
      write(*,*) 'check_OptF_pars: Error reading [IndStartRandom]'
      info = 108
      return

 109  continue
      write(*,*) 'check_OptF_pars: Error reading [IndStopIterCnd]'
      info = 109
      return

 110  continue
      write(*,*) 'check_OptF_pars: Error reading [IndLocalMinVer]'
      info = 110
      return

      end
