!DIR$ FIXEDFORMLINESIZE:132
      subroutine check_pars(info)
      use blocks
      use Fourier
      implicit none
      integer*4, intent(out) :: info

      info = 0

      open(unit=70, file='Inv.par', status='old',err=100)

      read(70,*,err=101,end=101) Method
      read(70,*,err=102,end=102) N
      read(70,*,err=103,end=103) N1
      read(70,*,err=104,end=104) L
      read(70,*,err=105,end=105) eps

      close(unit=70)

c
c-------------------------------------------------------------------------------
c
      if     (Method .eq. 'CombSolver') then
         continue
      else if(Method .eq. 'OptFSolver') then
         continue
      else
         write(*,*) 'check_pars: Error on input: incorrect Method'
         info = -1
         return
      end if
c
c-------------------------------------------------------------------------------
c

      if     (N .lt. 3) then
         write(*,*) 'check_pars: Error on input: N<3'
         info = -2
         return
      else if(mod(N,2) .eq. 0) then
         write(*,*) 'check_pars: Error on input: N is even'
         info = -3
         return
      else if(N1 .lt. 1) then
         write(*,*) 'check_pars: Error on input: r<1'
         info = -4
         return
      else if(N1 .gt. N) then
         write(*,*) 'check_pars: Error on input: r>N'
         info = -5
         return
      end if

      N0 = N-N1
      M  = (N-1)/2

      if(L .lt. 1) then
         write(*,*) 'check_pars: Error on input: L<1'
         info = -6
         return
      else if(L .eq. M) then
         write(*,*) 'check_pars: Warning: L=M=(N-1)/2 (full DFT)'
      else if(L .gt. M) then
         write(*,*) 'check_pars: Error on input: L>M=(N-1)/2'
         info = -7
         return
      end if

      if(N1 .gt. M) then
         write(*,*) 'check_pars: Error on input: r>M'
         info = -8
         return
      end if

      if(eps .lt. rz) then
         write(*,*) 'check_pars: Error on input: eps<0'
         info = -9
         return
      else if(eps .gt. 100.0) then
         write(*,*) 'check_pars: Error on input: eps>100.0'
         info = -10
         return
      end if

      Nm1 = N-1
      Lp1 = L+1   
      Mp1 = M+1
      Mp2 = M+2
      del = two*pi/dfloat(N)
      LN = M*N
      allocate(E(0:LN))
      call make_E()

      const = dsqrt(dfloat(N)/two)

      return

 100  continue
      write(*,*) 'check_pars: Error opening Inv.par'
      info = 100
      return

 101  continue
      write(*,*) 'check_pars: Error reading [Method]'
      info = 101
      return

 102  continue
      write(*,*) 'check_pars: Error reading [N]'
      info = 102
      return

 103  continue
      write(*,*) 'check_pars: Error reading [r]'
      info = 103
      return

 104  continue
      write(*,*) 'check_pars: Error reading [L]'
      info = 104
      return

 105  continue
      write(*,*) 'check_pars: Error reading [err]'
      info = 105
      return

      end
